/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.pl.product.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.springblade.api.utils.FileUtils;
import org.springblade.common.utils.PostGet;
import org.springblade.core.http.util.HttpUtil;
import org.springblade.core.oss.model.BladeFile;
import org.springblade.modules.pl.product.entity.ProductEntity;
import org.springblade.modules.pl.product.vo.ProductVO;
import org.springblade.modules.pl.product.excel.ProductExcel;
import org.springblade.modules.pl.product.mapper.ProductMapper;
import org.springblade.modules.pl.product.service.IProductService;
import org.springblade.modules.pl.productModel.entity.ProductModelEntity;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.core.mp.base.BaseServiceImpl;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 产品表 服务实现类
 *
 * @author BladeX
 * @since 2023-12-05
 */
@Service
@Slf4j
public class ProductServiceImpl extends BaseServiceImpl<ProductMapper, ProductEntity> implements IProductService {

	@Override
	public IPage<ProductVO> selectProductPage(IPage<ProductVO> page, ProductVO product) {
		return page.setRecords(baseMapper.selectProductPage(page, product));
	}


	@Override
	public List<ProductExcel> exportProduct(Wrapper<ProductEntity> queryWrapper) {
		List<ProductExcel> productList = baseMapper.exportProduct(queryWrapper);
		//productList.forEach(product -> {
		//	product.setTypeName(DictCache.getValue(DictEnum.YES_NO, Product.getType()));
		//});
		return productList;
	}

	@Override
	public void pushTripartite(String productCode, String fileUlr, ProductModelEntity productModel ,String result) {
		File file = FileUtils.getFileByUrl(fileUlr,".jpg");
		Map<String,Object> param = new HashMap<>();
		param.put("sn",productCode);
		param.put("result",result);
		param.put("file",file);
		log.info("产品-{}推送三方平台result：{},fileUrl：{}",productCode,result,fileUlr);
		String postResult = HttpUtil.post(productModel.getTripartiteUrl(), param);
		log.info("产品-{}推送三方平台结果：{}",productCode,postResult);
//		HttpUtil.post()
	}

	public static void main(String[] args) {
		Map<String,Object> param = new HashMap<>();
		param.put("sn","test1");
		param.put("result","OK");
		param.put("file",new File("C:\\Users\\86180\\Desktop\\logo\\logo2.jpg"));
		System.out.println(HttpUtil.post("http://121.36.53.58:8099/js/a/mes/mesProductMpp/add", param));
	}
}
